/* -LICENSE-START-
 ** Copyright (c) 2018 Blackmagic Design
 **
 ** Permission is hereby granted, free of charge, to any person or organization
 ** obtaining a copy of the software and accompanying documentation covered by
 ** this license (the "Software") to use, reproduce, display, distribute,
 ** execute, and transmit the Software, and to prepare derivative works of the
 ** Software, and to permit third-parties to whom the Software is furnished to
 ** do so, all subject to the following:
 **
 ** The copyright notices in the Software and this entire statement, including
 ** the above license grant, this restriction and the following disclaimer,
 ** must be included in all copies of the Software, in whole or in part, and
 ** all derivative works of the Software, unless such copies or derivative
 ** works are solely in the form of machine-executable object code generated by
 ** a source language processor.
 **
 ** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 ** IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 ** FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 ** SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 ** FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 ** ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 ** DEALINGS IN THE SOFTWARE.
 ** -LICENSE-END-
 */

import Foundation
import CoreBluetooth

struct BMDCameraCharacteristics {
    static let kOutgoingCCU = CBUUID(string: "5DD3465F-1AEE-4299-8493-D2ECA2F8E1BB")
    static let kIncomingCCU = CBUUID(string: "B864E140-76A0-416A-BF30-5876504537D9")
    static let kTimecode = CBUUID(string: "6D8F2110-86F1-41BF-9AFB-451D87E976C8")
    static let kCameraStatus = CBUUID(string: "7FE8691D-95DC-4FC5-8ABD-CA74339B51B9")
    static let kDeviceName = CBUUID(string: "FFAC0C52-C9FB-41A0-B063-CC76282EB89C")
    static let kProtocolVersion = CBUUID(string: "8f1fd018-b508-456f-8f82-3d392bee2706")

    static let kMainCharacteristicUUIDs: [CBUUID] = [
        BMDCameraCharacteristics.kOutgoingCCU,
        BMDCameraCharacteristics.kIncomingCCU,
        BMDCameraCharacteristics.kTimecode,
        BMDCameraCharacteristics.kCameraStatus,
        BMDCameraCharacteristics.kDeviceName,
        BMDCameraCharacteristics.kProtocolVersion,
    ]

    static let kCameraManufacturer = CBUUID(string: "2A29")
    static let kCameraModel = CBUUID(string: "2A24")

    static let kCameraInfoCharacteristicUUIDs: [CBUUID] = [
        BMDCameraCharacteristics.kCameraManufacturer,
        BMDCameraCharacteristics.kCameraModel,
    ]
    
    static let kEncryptedCharacteristics: [CBUUID] = [
        BMDCameraCharacteristics.kOutgoingCCU,
        BMDCameraCharacteristics.kIncomingCCU,
        BMDCameraCharacteristics.kTimecode,
        BMDCameraCharacteristics.kCameraStatus,
    ]
    
    static func IsCharacteristicEncrypted(_ uuid: CBUUID) -> Bool {
        return kEncryptedCharacteristics.contains(uuid)
    }
}
